"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filesDb = exports.db = exports.Dexie = exports.FilesDb = exports.UiDb = void 0;
const fake_indexeddb_1 = require("fake-indexeddb");
const dexie_1 = __importDefault(require("dexie"));
class NyargsDb extends dexie_1.default {
    constructor(tableName, options = {}) {
        super(tableName, options);
    }
}
class UiDb extends NyargsDb {
    cache;
    constructor(options = {}) {
        super("UiDb", options);
        this.version(1).stores({
            cache: 'id++, *names, *commands, value, [commands+names], createdAt'
        });
        this.cache = this.table('cache');
    }
}
exports.UiDb = UiDb;
class FilesDb extends NyargsDb {
    files;
    constructor(options = {}) {
        super("FilesDb", options);
        this.version(1).stores({
            files: 'name, data, createdAt'
        });
        this.files = this.table('files');
    }
}
exports.FilesDb = FilesDb;
exports.Dexie = dexie_1.default;
const db = async (useFake) => {
    if (useFake === true) {
        return new UiDb({ indexedDB: fake_indexeddb_1.indexedDB, IDBKeyRange: fake_indexeddb_1.IDBKeyRange });
    }
    return new UiDb;
};
exports.db = db;
const filesDb = async (useFake) => {
    if (useFake === true) {
        return new FilesDb({ indexedDB: fake_indexeddb_1.indexedDB, IDBKeyRange: fake_indexeddb_1.IDBKeyRange });
    }
    return new FilesDb;
};
exports.filesDb = filesDb;
//# sourceMappingURL=index.js.map