"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const call_1 = require("../../shared/api/call");
const writePromise = async (fname, dat) => {
    console.log('writing...', JSON.parse(dat));
    var dataStr = `data:text/json;charset=utf-8,${dat.replace('\n', "\r\n")}`;
    const dlAnchorElem = document.createElement('a');
    document.body.appendChild(dlAnchorElem);
    dlAnchorElem.setAttribute("href", dataStr);
    dlAnchorElem.setAttribute("download", fname);
    dlAnchorElem.click();
    dlAnchorElem.remove();
};
const readPromise = async (fullPath) => {
    return (0, call_1.get)(fullPath, {}, {})
        .then(async (response) => {
        return response.text();
    });
};
const files = {
    read: (path, opts) => {
        if (opts) {
            console.warn('Warning; node options are ignored in the browser environment');
        }
        if (path.startsWith('input:')) {
            const domSelector = path.replace('input:', '');
            const elem = document.querySelector(domSelector);
            if (elem && elem.value) {
                return Promise.resolve(elem.value);
            }
            else {
                throw new Error(`Selector ${path} triggered dom search to read, but element was empty or not fouund`);
            }
        }
        return readPromise(path);
    },
    write: (path, data, opts) => {
        if (opts) {
            console.warn('Warning; node options are ignored in the browser environment');
        }
        return writePromise(path, data);
    },
    mkdir: async (arg1, arg2, arg3) => 'Not making directory in browser environment'
};
exports.default = files;
//# sourceMappingURL=index.js.map