"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isNode_1 = __importDefault(require("../../../shared/utils/isNode"));
const shared_1 = require("../../../shared");
const assert_1 = __importStar(require("./assert"));
const termOut = (fn, plainLogger) => {
    return (msgs) => {
        msgs.forEach(msg => {
            const strMsg = typeof msg === 'string' ? msg : JSON.stringify(msg, null, 2);
            fn(strMsg, plainLogger);
        });
    };
};
const termRedMsg = (str, plainLogger) => plainLogger(`\x1b[31m%s\x1b[0m`, str);
const termGreenMsg = (str, plainLogger) => plainLogger(`\x1b[32m%s\x1b[0m`, str);
const browserRedMsg = (str, plainLogger) => plainLogger(`%c${str}`, "color: red;");
const browserGreenMsg = (str, plainLogger) => plainLogger(`%c${str}`, "color: green;");
const getLogger = () => {
    const log = (0, shared_1.getConfig)('messageUser');
    const red = (0, isNode_1.default)() ? termOut(termRedMsg, log) : termOut(browserRedMsg, log);
    const green = (0, isNode_1.default)() ? termOut(termGreenMsg, log) : termOut(browserGreenMsg, log);
    return { red, green, log };
};
const getTestLogger = async (arg1) => {
    const { red, green, log } = getLogger();
    return (anArg) => {
        log(`ran test ${arg1.positional[0]} ${anArg.commands.join(' ')}`);
        const testResData = {
            expected: anArg.expected, received: anArg.received
        };
        if (anArg.result.includes(assert_1.FAIL)) {
            red([assert_1.FAIL]);
            red([testResData]);
        }
        else {
            green([assert_1.PASS]);
            green([testResData]);
        }
    };
};
const test = {
    help: {
        description: 'test functions',
    },
    fn: async (arg1, arg2) => {
        const logger = await getTestLogger(arg1);
        Object.values(arg2).map(logger);
    },
    submodules: {
        assert: assert_1.default
    }
};
exports.default = test;
//# sourceMappingURL=index.js.map