"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cache_1 = require("../../runtime/cache");
const shared_1 = require("../../shared");
const m = {
    help: {
        description: 'Back up the cache; in node, export it as a json file and write it to disk; or in browser, download to user',
        examples: {
            '-p subdir/foo -f backup.json': 'Export cache and save it in a file at "./subdir/foo/backup.json" or download to browser as subdir_foo_backup.json'
        }
    },
    fn: async (args) => {
        const now = Date.now();
        const db = await (0, shared_1.get)('db');
        const newId = await db.cache.add({
            commands: ['la', 'tra'],
            names: ['fa', 're'],
            value: 1,
            createdAt: now
        });
        await db.cache.delete(newId);
        const dbBack = db.backendDB();
        return (0, cache_1.exportDb)(args.p, args.f, dbBack);
    },
    yargs: {
        filename: {
            alias: 'f',
            type: 'string',
            default: `back-${Date.now()}.json`
        },
        path: {
            alias: 'p',
            type: 'string',
            default: `data`
        }
    }
};
exports.default = m;
//# sourceMappingURL=back.js.map