"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cache_1 = require("../../runtime/cache");
const index_1 = require("../../shared/index");
exports.default = {
    help: {
        description: 'import a json file to the cache db (i.e. a file previously saved using "cache back ..." command',
        options: {},
        examples: {}
    },
    fn: async (args) => {
        const db = await (0, index_1.get)('db');
        const now = Date.now();
        const newId = await db.cache.add({
            commands: ['la', 'tra'],
            names: ['fa', 're'],
            value: 1,
            createdAt: now
        });
        await db.cache.delete(newId);
        const result = await (0, cache_1.importDb)(args.filename, db.backendDB());
        await db.cache.delete(now);
        return result;
    },
    yargs: {
        filename: {
            alias: 'f',
            type: 'string',
            default: `back-${Date.now()}.json`
        },
        path: {
            alias: 'p',
            type: 'string',
            default: `data`
        }
    }
};
//# sourceMappingURL=import.js.map