"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const one_1 = __importDefault(require("./one"));
const cm = {
    parallel: true,
    help: {
        description: 'nested commands that log test code',
        options: {
            '--async': 'do not call children but rather pass the child function wrappers to the parentmost module. the parent controls calling them in whatever order it specifies'
        },
    },
    fn: async function test(_, priors) {
        const results = await Promise.all(priors.map(async ([nm, fn]) => {
            const res = await fn(priors);
            return res;
        }));
        return {
            topMessage: 'nestd ASYNC call from parentmost',
            childMessages: results
        };
    },
    submodules: {
        one: one_1.default
    }
};
exports.default = cm;
//# sourceMappingURL=index.js.map