import { Result } from '../appTypes';
import { Dexie } from 'dexie';
import { QueryParams } from './api/call';
export declare const isNode: () => any;
export interface HistoryListener {
    default?: any;
    on: Function;
}
export interface RenewReader {
    (arg1: string, arg2: ReadlineInterface, htmlContainer?: any): Promise<ReadlineInterface>;
    default?: RenewReader;
}
interface PrintResult {
    (arg1: Result): Promise<boolean>;
    default?: PrintResult;
}
interface TerminalUtils {
    default?: TerminalUtils;
    matchUp: (arg1: any) => boolean;
    matchDown: (arg1: any) => boolean;
    eventName: string;
    clearCurrent: (rl?: ReadlineInterface) => void;
}
declare type PartialFs = {
    default?: PartialFs;
    writeFileSync: Function;
    readFileSync: (path: string, encoding: any, opts: any) => Promise<string>;
    readFile?: (path: string, encoding: string | object, params?: QueryParams, basePath?: string) => Promise<string>;
};
declare type Deps = {
    'fs'?: Promise<PartialFs>;
    'shelljs'?: Promise<{
        default?: any;
        mkdir: Function;
    }>;
    'readline'?: Promise<Readline>;
    'historyListener'?: Promise<HistoryListener>;
    'terminalUtils'?: Promise<TerminalUtils>;
    'renewReader'?: Promise<RenewReader>;
    'printResult'?: Promise<PrintResult>;
    'db'?: Promise<Db>;
    'Dexie'?: Promise<DexieType>;
};
export interface ReadlineInterface {
    question: Function;
    write: Function;
    close: Function;
    line: string;
}
export declare type Readline = {
    default?: Readline;
    createInterface: (arg: {
        input: any;
        output: any;
        prompt: any;
    }) => ReadlineInterface;
    utils?: {
        matchUp: Function;
        matchDown: Function;
        eventName: string;
    };
    getInput?: (arg1: string, arg2?: string) => Promise<string>;
};
declare type DepName = 'fs' | 'shelljs' | 'readline' | 'historyListener' | 'terminalUtils' | 'renewReader' | 'printResult' | 'db' | 'Dexie';
declare type Awaitable = <DN extends keyof Deps>(dn: DN) => Promise<Deps[typeof dn]>;
export declare const deps: {
    get: Awaitable;
    set: <D extends DepName>(depName: D, newDep: Deps[D]) => void;
};
declare type DexieType = (typeof Dexie);
declare type Db = any;
export declare const setDeps: ({ historyListener, terminalUtils, renewReader, printResult, readline, fs, shelljs, db, Dexie }: {
    historyListener: HistoryListener;
    terminalUtils: TerminalUtils;
    renewReader: RenewReader;
    printResult: PrintResult;
    readline: Readline;
    fs: PartialFs;
    shelljs: {
        mkdir: Function;
        default?: {
            mkdir: Function;
        };
    };
    db: Db;
    Dexie: DexieType;
}) => void;
export declare const commands: () => void;
export {};
