"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.commands = exports.setDeps = exports.deps = exports.isNode = void 0;
const isNode = () => {
    try {
        const fn = new Function("try { return window.document === undefined } catch(e) { return true; }");
        return fn();
    }
    catch (e) {
        console.log('presuming browser environment because isNode() errored out');
        return false;
    }
};
exports.isNode = isNode;
const depsRef = {} = {};
let initResolve;
const init = new Promise((resolve) => {
    initResolve = resolve;
});
const getDeps = async (dn) => {
    await init;
    if (!depsRef[dn])
        throw new Error(`No dep available at ${dn}`);
    return depsRef[dn].then((resolvedDep) => {
        if (resolvedDep.default)
            return resolvedDep.default;
        return resolvedDep;
    });
};
exports.deps = ({
    get: getDeps,
    set: (depName, newDep) => {
        depsRef[depName] = newDep;
    }
});
const setDeps = ({ historyListener, terminalUtils, renewReader, printResult, readline, fs, shelljs, db, Dexie }) => {
    exports.deps.set('fs', Promise.resolve(fs));
    exports.deps.set('shelljs', Promise.resolve(shelljs));
    exports.deps.set('historyListener', Promise.resolve(historyListener));
    exports.deps.set('terminalUtils', Promise.resolve(terminalUtils));
    exports.deps.set('renewReader', Promise.resolve(renewReader));
    exports.deps.set('readline', Promise.resolve(readline));
    exports.deps.set('printResult', Promise.resolve(printResult));
    exports.deps.set('db', Promise.resolve(db));
    exports.deps.set('Dexie', Promise.resolve(Dexie));
    initResolve();
};
exports.setDeps = setDeps;
const commands = () => {
    if ((0, exports.isNode)()) {
    }
};
exports.commands = commands;
//# sourceMappingURL=dynamic.js.map