"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dynamic_1 = require("../../dynamic");
const dynamic_2 = require("../../dynamic");
const printResult = async (result) => {
    if (result.argv.help === true) {
        return true;
    }
    if (!result.isMultiResult) {
        console.log(result);
        return true;
    }
    else {
        let didLog = false;
        Object.entries(result.list).forEach(([idx, res]) => {
            console.log(`${idx} result:`);
            console.log(res);
            didLog = true;
            if (result.argv[idx].logArgs === true) {
                console.log(`${idx} computed arguments:`);
                console.log(result.argv[idx]);
                console.log('all args:');
                console.log(result);
            }
        });
        return didLog;
    }
};
const makeTriggerInput = (write) => (inp = "brackets get -s 'i go'") => {
    write(inp);
    write("\n");
};
const terminalUtils = {
    matchUp: (obj) => obj.name === 'up',
    matchDown: (obj) => obj.name === 'down',
    eventName: 'keypress',
    clearCurrent: (rl) => {
        rl.write(null, { ctrl: true, name: 'u' });
    }
};
const renewReader = async (pr, curElement) => {
    const readline = await dynamic_2.deps.get('readline');
    curElement?.close();
    const rl = readline.createInterface({
        input: process.stdin,
        output: process.stdout,
        prompt: pr
    });
    return rl;
};
const fs_1 = __importDefault(require("fs"));
const shelljs_1 = __importDefault(require("shelljs"));
const readline_1 = __importDefault(require("readline"));
const db_1 = require("./db");
(0, dynamic_1.setDeps)({
    fs: {
        readFileSync: async (path, encoding, opts) => {
            const returnable = fs_1.default.readFileSync(path, { encoding, ...opts });
            if (typeof returnable === 'string') {
                return returnable;
            }
        },
        readFile: async (path, encoding, opts) => {
            const returnable = fs_1.default.readFileSync(path, { encoding, ...opts });
            if (typeof returnable === 'string') {
                return returnable;
            }
        },
        writeFileSync: fs_1.default.writeFileSync
    },
    shelljs: shelljs_1.default,
    readline: readline_1.default,
    historyListener: {
        on: (_, fn) => {
            process.stdin.on('keypress', fn);
        }, default: null
    },
    terminalUtils,
    renewReader,
    printResult,
    db: db_1.db,
    Dexie: db_1.Dexie
});
//# sourceMappingURL=shims.js.map