"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = require("fs/promises");
const readPromise = async (path, opts) => {
    return new Promise(async (resolve, reject) => {
        const ret = await (0, promises_1.readFile)(path, opts);
        if (typeof ret === 'string') {
            return resolve(ret);
        }
        else
            return reject(new Error(`Readfile should return a string.`));
    });
};
const writePromise = async (data, encoding, nodeOnly) => {
    return new Promise(async (resolve, reject) => {
        let ret;
        if (nodeOnly) {
            console.warn('warning; "files" is meant to be universal; but a  third argument to write will be ignored in the browser runtime.');
            ret = await (0, promises_1.writeFile)(data, encoding, nodeOnly);
        }
        else {
            ret = await (0, promises_1.writeFile)(data, encoding);
        }
        if (typeof ret === 'string') {
            return resolve(ret);
        }
        else
            return reject(new Error(`Writefile should return a string.`));
    });
};
exports.default = ({
    read: readPromise,
    write: writePromise
});
//# sourceMappingURL=index.js.map