"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.get = exports.post = exports.EP_BRACKETS = void 0;
const isomorphic_fetch_1 = __importDefault(require("isomorphic-fetch"));
exports.EP_BRACKETS = 'brackets';
async function postData(url = '', data, options) {
    const response = await (0, isomorphic_fetch_1.default)(url, {
        ...{
            method: 'POST',
            cache: 'no-cache',
            headers: {
                'Content-Type': 'application/json'
            },
            redirect: 'follow',
            referrerPolicy: 'no-referrer',
            body: JSON.stringify({ data })
        }, ...options
    });
    return response.json();
}
const post = (rqBase, queryParams, options = {}) => {
    return postData(rqBase, queryParams, options);
};
exports.post = post;
const get = (rqBase, queryParams, options = {}) => {
    const concattedParams = Object.entries(queryParams).reduce((accum, [key, val]) => {
        const separator = accum ? '&' : '?';
        return `${accum}${separator}${key}=${val}`;
    }, '');
    const queryString = `${rqBase}${concattedParams}`;
    const fetchCall = (0, isomorphic_fetch_1.default)(queryString, options);
    return fetchCall;
};
exports.get = get;
//# sourceMappingURL=call.js.map