import { Files, PartialFs, Db, TerminalUtils, PrintResult, HistoryListener, RenewReader, Readline, SaveHistory, LoadHistory, Configuration, ConfigOptions, SetAll } from "./utils/types";
declare type Awaitable = <DN extends keyof Deps>(dn: DN) => Promise<Deps[typeof dn]>;
export declare const configuration: Configuration;
export declare const configured: {
    resolver: null | (() => void);
    ready: null | Promise<void>;
};
export declare const get: Awaitable;
export declare const set: <D extends keyof Deps>(depName: D, newDep: Deps[D]) => void;
export declare const getConfig: <Dn extends keyof ConfigOptions>(dn: Dn) => ConfigOptions[Dn];
export declare const configure: <Settable extends keyof ConfigOptions>(optionOrPlatform: Settable | keyof Configuration, optionOrValue?: Settable | ConfigOptions[Settable], value?: ConfigOptions[Settable]) => void;
export declare type Configure = typeof configure;
declare type Deps = {
    'setAll'?: SetAll;
    'fs'?: PartialFs;
    'files'?: Files;
    'db'?: Db;
    'readline'?: Readline;
    'renewReader'?: RenewReader;
    'historyListener'?: HistoryListener;
    'terminalUtils'?: TerminalUtils;
    'printResult'?: PrintResult;
    'saveHistory'?: SaveHistory;
    'loadHistory'?: LoadHistory;
};
export {};
