declare type ReplaceFunctionArg = (priorStdout: string) => string | Promise<string> | null;
declare type Command = string | ReplaceFunctionArg;
interface Api {
    cli: (command: string) => CliCalled;
    replace: (fn: ReplaceFunctionArg) => CliCalled;
    wait: (commandArg: ReplaceFunctionArg | string) => CliCalled;
}
interface CliCalled extends Api {
    idx: number;
    promise: Promise<void>;
    isDone: boolean;
    code: number | null;
    stdout: string | number | null;
    stderr: string | number | null;
    isFirst: boolean;
    commands: Command[];
}
export declare function cli(command: string): CliCalled;
export declare const grn: (str: string) => string;
export declare const termGreenMsg: (str: string) => void;
export {};
