import { Modules } from "./types";
declare type Opt = {
    type?: 'string' | 'number' | 'boolean' | 'bool';
    array?: boolean;
    alias?: string;
};
declare type Opts = {
    [optName: string]: Opt;
} & typeof yargsOptions;
declare const yargsOptions: {
    commands: {
        array: boolean;
        alias: string;
    };
    names: {
        array: boolean;
        alias: string;
    };
};
declare type ParsedArg = string | number | boolean | (string | number | boolean)[];
export declare type ParsedCli = {
    '_': string[];
    'positionalNonCommands': null | (string | number)[];
    'c:c': string[];
    'commands': string[];
    'c:n': string[];
    'names': string[];
    temp?: any;
    [optName: string]: ParsedArg;
};
export declare const parse: (modules: Modules, rawOpts: Opts, rawIn: string | string[]) => ParsedCli;
export {};
