"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.platformIsNode = void 0;
const isNode_1 = __importDefault(require("./isNode"));
exports.platformIsNode = (0, isNode_1.default)();
const importPlatform = async () => {
    if (exports.platformIsNode) {
        const main = await Promise.resolve().then(() => __importStar(require('../../server/exports')));
        await Promise.resolve().then(() => __importStar(require('fake-indexeddb/auto')));
        return { main };
    }
    const main = (await Promise.resolve().then(() => __importStar(require('../../browser/exports'))));
    return { main };
};
const createAppFromFn = async (main, fn) => {
    return fn(main);
};
const createAppFromObj = async (main, modules, configurators, prompt) => {
    const { cache, program, test, repl, setDictionary, configure, nest, element, match } = main;
    const { config = {}, programs = {} } = configurators;
    setDictionary(programs);
    Object.entries(config).forEach(([configurable, configVal]) => configure(configurable, configVal));
    repl({ ...modules, match, cache, program, test, nest, element }, prompt);
};
const createApp = async (fnOrModules, configurators, prompt) => {
    if (!exports.platformIsNode) {
        let init;
        if (configurators) {
            init = configurators.config.init;
        }
        if (!init) {
            init = (await Promise.resolve().then(() => __importStar(require('../../browser/init')))).default;
        }
        await init();
    }
    const { main } = await importPlatform();
    if (typeof fnOrModules === 'function') {
        return createAppFromFn(main, fnOrModules);
    }
    return createAppFromObj(main, fnOrModules, configurators, prompt);
};
exports.default = createApp;
//# sourceMappingURL=createApp.js.map