"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeGetLastN = exports.lastFive = void 0;
exports.lastFive = [];
const makeGetLastN = () => {
    return (elem, n) => {
        const lastTwo = exports.lastFive.slice(exports.lastFive.length - n).reduce((accum, ke, idx) => {
            if (ke.type !== 'keydown') {
                if (ke.sequence === undefined) {
                    console.log('rejecting key; type', ke, 'type is ', ke.type);
                    return accum;
                }
            }
            if (elem !== true) {
                if (elem !== ke.target)
                    return accum;
            }
            if (typeof ke.key === 'string' || typeof ke.key === 'number') {
                return `${accum}-${ke.key}`;
            }
            if (typeof ke.sequence === 'string') {
                const keAsAny = ke;
                let ret = accum ?? '';
                const CTRL = keAsAny.ctrl && !ret.includes('-Control') ? '-Control' : '';
                const META = keAsAny.meta && !ret.includes('-Alt') ? '-Alt' : '';
                const SHIFT = keAsAny.shift && !ret.includes('-Shift') ? '-Shift' : '';
                const nm = keAsAny.name && keAsAny.name.length === 1 && keAsAny.shift
                    ? keAsAny.name.toUpperCase()
                    : keAsAny.name;
                const totSpecial = (CTRL ? 1 : 0) + (META ? 1 : 0) + (SHIFT ? 1 : 0);
                const pass = `${CTRL}${META}${SHIFT}`;
                const prev = ret.split('-').filter(x => !!x);
                prev.push(nm);
                const finalPrev = prev.slice(0 + totSpecial, prev.length);
                let final = `${pass}-${finalPrev.join('-')}`;
                return final;
            }
        }, '');
        return lastTwo;
    };
};
exports.makeGetLastN = makeGetLastN;
//# sourceMappingURL=makeGetLastN.js.map