"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printResult = exports.getText = void 0;
const const_1 = require("./const");
const strJson = (arg) => JSON.stringify(arg, null, 2);
const getText = (argv, result) => {
    if (argv.help === true) {
        return '';
    }
    if (result.isMultiResult === false) {
        console.log(result[const_1.RESULT_KEY]);
        return strJson(result[const_1.RESULT_KEY]);
    }
    else {
        let accumTxt = '';
        Object.entries(result.list).forEach(([idx, res]) => {
            accumTxt = `${accumTxt}
${idx} result:
${strJson(res)}
`;
            if (argv.logArgs === true) {
                accumTxt = `${accumTxt}
${idx} computed arguments:
${strJson(argv)}

all args:
${strJson(result)}`;
            }
        });
        return accumTxt;
    }
};
exports.getText = getText;
const printResult = async (argv, result, optional) => {
    if (argv.help === true) {
        return true;
    }
    const txt = (0, exports.getText)(argv, result);
    console.log(txt);
    return txt.length > 0;
};
exports.printResult = printResult;
//# sourceMappingURL=printResult.js.map