declare type GameTurnData = {
    [gameId: number]: {
        [turn: string]: {
            [legId: string]: any[];
        };
    };
};
export declare type PilotData = {
    [gameId: number]: {
        [turn: string]: {
            [piName: string]: {
                location: [number, number, number];
            };
        };
    };
};
declare type OsData = {
    location: [number, number, number];
};
export declare type OsGameData = {
    [gameId: number]: {
        [osName: string]: OsData;
    };
};
export declare const osData: (gameId: number, gamesData: OsGameData) => (turnDat: any[]) => OsGameData | null;
export declare const pilotData: (gameId: number, gamesData: any) => (turnDat: any[]) => PilotData | null;
export declare const linesFromTurnData: (gameId: number, gamesData?: any) => (turnDat: any[]) => GameTurnData | null;
declare type LegsWithTurns = {
    [lid: string]: {
        [num: number]: [number, number, number];
    };
};
export declare const legsWithTurns: (turnDat: any[]) => LegsWithTurns | null;
declare type PilotsWithTurns = {
    [pid: string]: {
        [num: number]: [number, number, number];
    };
};
export declare const pilotsWithTUrns: (turnDat: any[]) => PilotsWithTurns | null;
export {};
