"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pilotsWithTUrns = exports.legsWithTurns = exports.linesFromTurnData = exports.pilotData = exports.osData = void 0;
const legLookup = (llarg1, turnDat) => {
    const lookup = turnDat.find((datum) => {
        if ((typeof datum === 'string') && llarg1.length === 0) {
            console.log('returning as name', datum);
            return true;
        }
        const name = (typeof datum === 'string') ? datum : datum[0];
        console.log('name settled on', name.startsWith(llarg1));
        const ret = name.startsWith(llarg1);
        console.log('matched?', ret);
        return ret;
    });
    const returnable = lookup && Array.isArray(lookup) ? lookup[1] : lookup ?? null;
    return returnable;
};
const osData = (gameId, gamesData) => (turnDat) => {
    if (typeof gamesData !== 'object')
        throw new Error(`Expected an object for ongoing game data.`);
    if (!Array.isArray(turnDat))
        throw new Error(`Expected array to create lines`);
    const init = gamesData[gameId] || {};
    const reducedIntoInit = turnDat.reduce((accum, turnLegs) => {
        const retVal = { ...accum };
        turnLegs.forEach((turnLeg) => {
            const location = legLookup('location', turnLeg);
            const os = turnLeg.find((elem) => typeof elem === 'string');
            if (location === null || os === null)
                throw new Error(`could not find os name, term "location" or  some combination in ${JSON.stringify(turnLeg, null, 2)}`);
            console.log('location', location);
            const osDat = { location };
            retVal[os] = retVal[os] ? { ...retVal[os], ...osDat } : osDat;
        });
        return {
            ...accum, ...retVal
        };
    }, init);
    return { ...gamesData, [gameId]: reducedIntoInit };
};
exports.osData = osData;
const pilotData = (gameId, gamesData) => (turnDat) => {
    console.log('args', gamesData, turnDat);
    if (typeof gamesData !== 'object')
        throw new Error(`Expected an object for ongoing game data.`);
    if (!Array.isArray(turnDat))
        throw new Error(`Expected array to create lines`);
    const init = (gamesData[gameId] ?? {});
    const reducedIntoInit = turnDat.reduce((accum, turnLegs, turnIdx) => {
        const retVal = { ...accum };
        turnLegs.forEach((turnLeg) => {
            const turn = legLookup('turn', turnLeg);
            const pilotName = turnLeg.find((elem) => typeof elem === 'string');
            const location = legLookup('location', turnLeg);
            const os = legLookup('os', turnLeg);
            if (turn === null || pilotName === null || location === null || os === null)
                throw new Error(`could not find pilot name, turn, "current", or os or some combination in ${JSON.stringify(turnLeg, null, 2)}`);
            retVal[turn] = retVal[turn] ?? {};
            retVal[turn][pilotName] = retVal[turn][pilotName] ?? {};
            retVal[turn][pilotName].location = location;
        });
        return {
            ...accum, ...retVal
        };
    }, init);
    return { ...gamesData, [gameId]: reducedIntoInit };
};
exports.pilotData = pilotData;
const linesFromTurnData = (gameId, gamesData = {}) => (turnDat) => {
    if (typeof gamesData !== 'object')
        throw new Error(`Expected an object for ongoing game data.`);
    if (!Array.isArray(turnDat))
        throw new Error(`Expected array to create lines`);
    const init = (gamesData[gameId] ?? {});
    const reducedIntoInit = turnDat.reduce((accum, turnLegs, turnIdx) => {
        const retVal = { ...accum };
        turnLegs.forEach((turnLeg) => {
            const turn = legLookup('turn', turnLeg);
            const legId = legLookup('leg', turnLeg);
            if (turn === null || legId === null)
                throw new Error(`could not find turn, leg,  or some combo, in ${JSON.stringify(turnLeg, null, 2)}`);
            retVal[turn] = retVal[turn] ?? {};
            const turnList = retVal[turn];
            turnList.legPaths = turnList.legPaths ?? {};
            retVal[turn][legId] = retVal[turn][legId] ?? {};
        });
        return {
            ...accum, ...retVal
        };
    }, init);
    return { ...gamesData, [gameId]: reducedIntoInit };
};
exports.linesFromTurnData = linesFromTurnData;
const legsWithTurns = (turnDat) => {
    if (typeof turnDat !== 'object')
        throw new Error(`Expected an object for ongoing game data.`);
    if (!Array.isArray(turnDat))
        throw new Error(`Expected array to create lines`);
    const reducedToObj = turnDat.reduce((accum, turnLegs, turnIdx) => {
        turnLegs.forEach((turnLeg) => {
            console.log('turnLeg', turnLeg);
            const turn = legLookup('turn', turnLeg);
            const legId = legLookup('leg', turnLeg);
            const current = legLookup('current', turnLeg);
            if (turn === null || legId === null || current === undefined) {
                throw new Error(`could not find turn, leg,  or some combo, in ${JSON.stringify(turnLeg, null, 2)}`);
            }
            if (current === 'null')
                return;
            console.log('setting data', turn, legId, current);
            const leg = accum[legId] ?? {};
            console.log('leg before', accum[legId]);
            accum[legId] = { ...accum[legId] ?? {}, [turn]: current };
            console.log('leg', leg);
            console.log('outgoing', accum[legId]);
        });
        return accum;
    }, {});
    return reducedToObj;
};
exports.legsWithTurns = legsWithTurns;
const pilotsWithTUrns = (turnDat) => {
    if (typeof turnDat !== 'object')
        throw new Error(`Expected an object for ongoing game data.`);
    if (!Array.isArray(turnDat))
        throw new Error(`Expected array to create lines`);
    const reducedToObj = turnDat.reduce((accum, turnLegs) => {
        turnLegs.forEach((turnLeg) => {
            const turn = legLookup('turn', turnLeg);
            const piName = turnLeg.find((elem) => typeof elem === 'string');
            const location = legLookup('location', turnLeg);
            if (turn === null || piName === null)
                throw new Error(`could not find turn, leg,  or some combo, in ${JSON.stringify(turnLeg, null, 2)}`);
            const leg = accum[piName] ?? {};
            leg[turn] = location;
            accum[piName] = leg;
        });
        return accum;
    }, {});
    return reducedToObj;
};
exports.pilotsWithTUrns = pilotsWithTUrns;
//# sourceMappingURL=prologAdaptors.js.map