declare type ObjectOrFailure = object | 'fail';
interface Answer {
    prolog: string;
    json: ObjectOrFailure;
}
export declare type Answers = Answer[];
export declare type AnswersWithTerms = {
    results: Answers;
    queryTerms: string[];
};
export declare type DestructuredAnswer = {
    predicates: string[];
    destructured: {
        [str: string | number]: any;
    };
};
declare type Term = Omit<Omit<string, "./2">, "[]/0">;
export declare type Predicates = Term[];
export declare const destructureAnswers: (ans: Answers) => DestructuredAnswer[];
declare type FlattenedBinding = {
    [bindingName: string]: any;
};
export declare const destructureSwipl: (data?: any[]) => FlattenedBinding[];
export {};
